#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/termios.h>
#include <stdlib.h>
#include <sys/poll.h>
#include "tcpwm.h"

int my_ioctl(int fd, unsigned int cmd, void *arg) {
	if (ioctl(fd, cmd, arg) < 0) {
		perror("ioctl");
	}
	return 0;
}

int main() {
	unsigned int minval = 33563;
	unsigned int maxval = 35813;

	int fd_steering;
	int fd_driving;
	unsigned int z = 37500; /* Ergibt 20 ms */
	unsigned int i;
	unsigned int j = 0;

	unsigned int middle = minval + ((maxval - minval)/2);  
	unsigned int drive_control = middle + 100;

	fd_steering = open("/dev/tcpwm0", O_RDONLY);
	fd_driving = open("/dev/tcpwm1", O_RDONLY);
	if (fd_steering < 0) {
		perror("Cannot open /dev/tcpwm0");
	}
	if (fd_driving < 0) {
		perror("Cannot open /dev/tcpwm1");
	}
	fprintf(stderr, "Now setting new RC (fd_steering=%d, fd_driving=%d)\n", fd_steering, fd_driving);
	/* Set full timeframe */
	my_ioctl(fd_steering, TCPWM_SET_RC, &z);
	my_ioctl(fd_driving, TCPWM_SET_RC, &z);
	my_ioctl(fd_driving, TCPWM_SET_RA, &middle);
	fprintf(stderr, "'driving' around ... \n");
	sleep (1);
	/* start car */
	my_ioctl(fd_driving, TCPWM_SET_RA, &drive_control);
	fprintf(stderr, "Sweeping, through the values, RC is: %d.\n", j);
	my_ioctl(fd_steering, TCPWM_SET_RA, &middle);
	for (i = middle; i < middle + 500; i += 100 ) {
		my_ioctl(fd_steering, TCPWM_SET_RA, &i);
		my_ioctl(fd_steering, TCPWM_GET_RA, &j);
		fprintf(stderr, "Now driving with RA %d.\n", j); 
		/* wait */
		if (poll(NULL, 0, 100) < 0) {
			perror("poll");
		}
	}
	/* Stop car */
	my_ioctl(fd_driving, TCPWM_SET_RA, &middle);
	close(fd_driving);
	close(fd_steering);
	exit(0);
}

