/* 
 * PWM driver for the Atmel AT91RM9200 ARM9 based microcontroller  
 * Enables the use of the built-in timer counter for generating 
 * PWM pulses. The pulse width and mark to space ratio is programmable 
 * with ioctls. 
 * Based on a very basic test driver from (C) J.Warren (jwarren at TinyLinux)
 * Most of the work (C) 2006 Carsten Gross (carsten@siski.de)
 * Version: 2006-05-04
*/

/* Create the following device nodes 
 * mknod /dev/tcpwm0 c TCPWM_MAJOR 0  
 * mknod /dev/tcpwm1 c TCPWM_MAJOR 1 
 * mknod /dev/tcpwm2 c TCPWM_MAJOR 2 
 * /dev/tcpwm0 will have it's output on AT91RM9200 pin PA17
 *      tcpwm1       -"-                AT91RM9200 pin PA19
 *      tcpwm2       -"-                AT91RM9200 pin PA21
 */

#ifndef _TCPWM_H_
#define _TCPWM_H_

#define TCPWM_GET_RA 0x6001
#define TCPWM_SET_RA 0x6002
#define TCPWM_GET_RC 0x6003
#define TCPWM_SET_RC 0x6004

#endif
